DefileWhisper = LibStub("AceAddon-3.0"):NewAddon("DefileWhisper", "AceEvent-3.0", "AceTimer-3.0")

function DefileWhisper:WaitFocusTarget()
    self.timerCount = self.timerCount + 1
    local current_ft = UnitName("focustarget")
    if self.focustarget ~= current_ft then
        SendChatMessage(">> Defile CAST ON YOU <<", "WHISPER", nil, current_ft)
        SendChatMessage(">> Defile on " .. current_ft .. " <<", "RAID_WARNING")
        self:CancelTimer(self.targetTimer)
    end
    -- If after 2 seconds, we haven't seen a change, we were probably too slow (unlikely)
    if self.timerCount == 20 then
        self:CancelTimer(self.targetTimer)
    end
end

function DefileWhisper:OnEnable()
    ChatFrame1:AddMessage("|cffffff00 DefileWhisper Loaded")
    self:RegisterEvent("UNIT_SPELLCAST_START")
end

function DefileWhisper:UNIT_SPELLCAST_START(event, unit, spell)
    if unit == "focus" then
        self.focustarget = UnitName("focustarget")
        if (self.focustarget ~= nil) and spell == "Defile" then
            self.timerCount = 0
            self.targetTimer = self:ScheduleRepeatingTimer("WaitFocusTarget", .1)
        end
    end
end
